import logging
import random

import discord

logger = logging.getLogger(__name__)


class Shuffler:
    def __init__(self) -> None:
        self.shuffle_tasks: set[int] = set()

    async def try_shuffle(self, guild: discord.Guild) -> bool:
        if guild.id in self.shuffle_tasks:
            return False

        self.shuffle_tasks.add(guild.id)
        await self.shuffle_nicks(guild)
        self.shuffle_tasks.discard(guild.id)
        return True

    async def shuffle_nicks(self, guild: discord.Guild) -> None:
        logger.info("Shuffle")
        members = guild.members
        if guild.owner:
            members.remove(guild.owner)

        nicks = [member.nick for member in members]

        random.shuffle(nicks)
        for member, nick in zip(members, nicks):
            logger.info(f"{member} {nick}")
            await member.edit(nick=nick)
        logger.info("Shuffle done")
